// This file was generated by qtwaylandscanner
// source file is /usr/share/plasma-wayland-protocols/kde-output-device-v2.xml

#ifndef QT_WAYLAND_KDE_OUTPUT_DEVICE_V2
#define QT_WAYLAND_KDE_OUTPUT_DEVICE_V2

#include "wayland-kde-output-device-v2-client-protocol.h"
#include <QByteArray>
#include <QString>

struct wl_registry;

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")

namespace QtWayland {
    class  kde_output_device_v2
    {
    public:
        kde_output_device_v2(struct ::wl_registry *registry, int id, int version);
        kde_output_device_v2(struct ::kde_output_device_v2 *object);
        kde_output_device_v2();

        virtual ~kde_output_device_v2();

        void init(struct ::wl_registry *registry, int id, int version);
        void init(struct ::kde_output_device_v2 *object);

        struct ::kde_output_device_v2 *object() { return m_kde_output_device_v2; }
        const struct ::kde_output_device_v2 *object() const { return m_kde_output_device_v2; }
        static kde_output_device_v2 *fromObject(struct ::kde_output_device_v2 *object);

        bool isInitialized() const;

        static const struct ::wl_interface *interface();

        enum subpixel {
            subpixel_unknown = 0,
            subpixel_none = 1,
            subpixel_horizontal_rgb = 2,
            subpixel_horizontal_bgr = 3,
            subpixel_vertical_rgb = 4,
            subpixel_vertical_bgr = 5,
        };

        enum transform {
            transform_normal = 0,
            transform_90 = 1,
            transform_180 = 2,
            transform_270 = 3,
            transform_flipped = 4,
            transform_flipped_90 = 5,
            transform_flipped_180 = 6,
            transform_flipped_270 = 7,
        };

        enum capability {
            capability_overscan = 1, // if this output_device can use overscan
            capability_vrr = 2, // if this outputdevice supports variable refresh rate
            capability_rgb_range = 4, // if setting the rgb range is possible
        };

        enum vrr_policy {
            vrr_policy_never = 0,
            vrr_policy_always = 1,
            vrr_policy_automatic = 2,
        };

        enum rgb_range {
            rgb_range_automatic = 0,
            rgb_range_full = 1,
            rgb_range_limited = 2,
        };

    protected:
        virtual void kde_output_device_v2_geometry(int32_t x, int32_t y, int32_t physical_width, int32_t physical_height, int32_t subpixel, const QString &make, const QString &model, int32_t transform);
        virtual void kde_output_device_v2_current_mode(struct ::kde_output_device_mode_v2 *mode);
        virtual void kde_output_device_v2_mode(struct ::kde_output_device_mode_v2 *mode);
        virtual void kde_output_device_v2_done();
        virtual void kde_output_device_v2_scale(wl_fixed_t factor);
        virtual void kde_output_device_v2_edid(const QString &raw);
        virtual void kde_output_device_v2_enabled(int32_t enabled);
        virtual void kde_output_device_v2_uuid(const QString &uuid);
        virtual void kde_output_device_v2_serial_number(const QString &serialNumber);
        virtual void kde_output_device_v2_eisa_id(const QString &eisaId);
        virtual void kde_output_device_v2_capabilities(uint32_t flags);
        virtual void kde_output_device_v2_overscan(uint32_t overscan);
        virtual void kde_output_device_v2_vrr_policy(uint32_t vrr_policy);
        virtual void kde_output_device_v2_rgb_range(uint32_t rgb_range);
        virtual void kde_output_device_v2_name(const QString &name);

    private:
        void init_listener();
        static const struct kde_output_device_v2_listener m_kde_output_device_v2_listener;
        static void handle_geometry(
            void *data,
            struct ::kde_output_device_v2 *object,
            int32_t x,
            int32_t y,
            int32_t physical_width,
            int32_t physical_height,
            int32_t subpixel,
            const char *make,
            const char *model,
            int32_t transform);
        static void handle_current_mode(
            void *data,
            struct ::kde_output_device_v2 *object,
            struct ::kde_output_device_mode_v2 *mode);
        static void handle_mode(
            void *data,
            struct ::kde_output_device_v2 *object,
            struct ::kde_output_device_mode_v2 *mode);
        static void handle_done(
            void *data,
            struct ::kde_output_device_v2 *object);
        static void handle_scale(
            void *data,
            struct ::kde_output_device_v2 *object,
            wl_fixed_t factor);
        static void handle_edid(
            void *data,
            struct ::kde_output_device_v2 *object,
            const char *raw);
        static void handle_enabled(
            void *data,
            struct ::kde_output_device_v2 *object,
            int32_t enabled);
        static void handle_uuid(
            void *data,
            struct ::kde_output_device_v2 *object,
            const char *uuid);
        static void handle_serial_number(
            void *data,
            struct ::kde_output_device_v2 *object,
            const char *serialNumber);
        static void handle_eisa_id(
            void *data,
            struct ::kde_output_device_v2 *object,
            const char *eisaId);
        static void handle_capabilities(
            void *data,
            struct ::kde_output_device_v2 *object,
            uint32_t flags);
        static void handle_overscan(
            void *data,
            struct ::kde_output_device_v2 *object,
            uint32_t overscan);
        static void handle_vrr_policy(
            void *data,
            struct ::kde_output_device_v2 *object,
            uint32_t vrr_policy);
        static void handle_rgb_range(
            void *data,
            struct ::kde_output_device_v2 *object,
            uint32_t rgb_range);
        static void handle_name(
            void *data,
            struct ::kde_output_device_v2 *object,
            const char *name);
        struct ::kde_output_device_v2 *m_kde_output_device_v2;
    };

    class  kde_output_device_mode_v2
    {
    public:
        kde_output_device_mode_v2(struct ::wl_registry *registry, int id, int version);
        kde_output_device_mode_v2(struct ::kde_output_device_mode_v2 *object);
        kde_output_device_mode_v2();

        virtual ~kde_output_device_mode_v2();

        void init(struct ::wl_registry *registry, int id, int version);
        void init(struct ::kde_output_device_mode_v2 *object);

        struct ::kde_output_device_mode_v2 *object() { return m_kde_output_device_mode_v2; }
        const struct ::kde_output_device_mode_v2 *object() const { return m_kde_output_device_mode_v2; }
        static kde_output_device_mode_v2 *fromObject(struct ::kde_output_device_mode_v2 *object);

        bool isInitialized() const;

        static const struct ::wl_interface *interface();

    protected:
        virtual void kde_output_device_mode_v2_size(int32_t width, int32_t height);
        virtual void kde_output_device_mode_v2_refresh(int32_t refresh);
        virtual void kde_output_device_mode_v2_preferred();
        virtual void kde_output_device_mode_v2_removed();

    private:
        void init_listener();
        static const struct kde_output_device_mode_v2_listener m_kde_output_device_mode_v2_listener;
        static void handle_size(
            void *data,
            struct ::kde_output_device_mode_v2 *object,
            int32_t width,
            int32_t height);
        static void handle_refresh(
            void *data,
            struct ::kde_output_device_mode_v2 *object,
            int32_t refresh);
        static void handle_preferred(
            void *data,
            struct ::kde_output_device_mode_v2 *object);
        static void handle_removed(
            void *data,
            struct ::kde_output_device_mode_v2 *object);
        struct ::kde_output_device_mode_v2 *m_kde_output_device_mode_v2;
    };
}

QT_WARNING_POP
QT_END_NAMESPACE

#endif
